
// MFCVirtualUIDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFCVirtualUI.h"
#include "MFCVirtualUIDlg.h"
#include "afxdialogex.h"
#include "Thinfinity.VirtualUI.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMFCVirtualUIDlg dialog

VirtualUI* m_VirtualUI;
JSObject* m_JSObject;

void GetUploadDir(std::wstring &Directory, bool &Handled) {
	MessageBox(0, Directory.c_str(), L"OnGetUploadDir called", 0);
}

void DownloadEnd(std::wstring &Filename) {
	MessageBox(0, Filename.c_str(), L"OnDownloadEnd called", 0);
}

void BrowserResize(int &Width, int &Height, bool &ResizeMaximized) {
	CString params;
	params.Format(_T("Width:%d Height:%d"), Width, Height);
	MessageBox(0, params, L"OnBrowserResize called", 0);
}


CMFCVirtualUIDlg::CMFCVirtualUIDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CMFCVirtualUIDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFCVirtualUIDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST3, ListControl1);
	DDX_Control(pDX, IDC_COMBO2, ComboLCView);
	DDX_Control(pDX, IDC_EDIT1, Edit1);
	DDX_Control(pDX, IDC_COMBO1, Combo1);
	DDX_Control(pDX, IDC_LIST1, ListBox1);
	DDX_Control(pDX, IDC_SPIN1, SpinControl1);
	DDX_Control(pDX, IDC_TREE1, TreeControl1);
	DDX_Control(pDX, IDC_TAB2, TabControl1);
	DDX_Control(pDX, IDC_SPLIT1, SplitButton1);
	DDX_Control(pDX, IDC_PROGRESS1, ProgressBar1);
	DDX_Control(pDX, IDC_EDIT4, EditInfo);
}

BEGIN_MESSAGE_MAP(CMFCVirtualUIDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CMFCVirtualUIDlg::OnBnClickedButton1)
	ON_CBN_SELCHANGE(IDC_COMBO2, &CMFCVirtualUIDlg::OnCbnSelchangeCombo2)
	ON_BN_CLICKED(IDC_BUTTON2, &CMFCVirtualUIDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CMFCVirtualUIDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CMFCVirtualUIDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CMFCVirtualUIDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CMFCVirtualUIDlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, &CMFCVirtualUIDlg::OnBnClickedButton7)
//	ON_NOTIFY(HDN_ITEMCHANGED, 0, &CMFCVirtualUIDlg::OnHdnItemchangedList3)
ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST3, &CMFCVirtualUIDlg::OnLvnItemchangedList3)
ON_BN_CLICKED(IDC_BUTTON8, &CMFCVirtualUIDlg::OnBnClickedButton8)
END_MESSAGE_MAP()

void CMFCVirtualUIDlg::InitControls() {
	mainMenu.LoadMenu(IDR_MENU1);
	SetMenu(&mainMenu);

	SpinControl1.SetRange(0, 100);
	ComboLCView.SetCurSel(0);

	imgList32.Create(IDB_BITMAPUSER32, 32, 2, RGB(0, 0, 0));
	ListControl1.SetImageList(&imgList32, LVSIL_NORMAL);

	imgList16.Create(IDB_BITMAPUSER16, 16, 1, RGB(0, 0, 0));
	ListControl1.SetImageList(&imgList16, LVSIL_SMALL);

	ListControl1.InsertColumn(0, _T("Name"), LVCFMT_LEFT, 90);
	ListControl1.InsertColumn(1, _T("Age"), LVCFMT_RIGHT, 40);
	ListControl1.InsertColumn(2, _T("City"), LVCFMT_LEFT, 70);

	ListControl1.InsertItem(0, _T("Mike"), 0);
	ListControl1.SetItemText(0, 1, _T("18"));
	ListControl1.SetItemText(0, 2, _T("New York"));

	ListControl1.InsertItem(1, _T("Roger"), 0);
	ListControl1.SetItemText(1, 1, _T("25"));
	ListControl1.SetItemText(1, 2, _T("Detroit"));

	ListControl1.InsertItem(2, _T("John"), 0);
	ListControl1.SetItemText(2, 1, _T("48"));
	ListControl1.SetItemText(2, 2, _T("Atlanta"));

	imgListTree.Create(IDB_BITMAPTREE, 16, 1, RGB(0, 0, 0));
	TreeControl1.SetImageList(&imgListTree, LVSIL_NORMAL);

	HTREEITEM parent = TreeControl1.InsertItem(_T("Item 1"), 0, 1);
	TreeControl1.InsertItem(_T("SubItem 1.1"), 0, 1, parent);
	TreeControl1.InsertItem(_T("SubItem 1.2"), 0, 1, parent);
	TreeControl1.InsertItem(_T("SubItem 1.3"), 0, 1, parent);
	TreeControl1.Expand(parent, TVE_EXPAND);
	parent = TreeControl1.InsertItem(_T("Item 2"), 0, 1);
	TreeControl1.InsertItem(_T("SubItem 2.1"), 0, 0, parent);
	TreeControl1.Expand(parent, TVE_EXPAND);
	parent = TreeControl1.InsertItem(_T("SubItem 2.2"), 0, 1, parent);
	TreeControl1.InsertItem(_T("SubItem 2.2.1"), 0, 1, parent);
	TreeControl1.InsertItem(_T("SubItem 2.2.2"), 0, 1, parent);
	TreeControl1.Expand(parent, TVE_EXPAND);

	TabControl1.InsertItem(0, _T("Tab Page 1"));
	TabControl1.InsertItem(1, _T("Tab Page 2"));
	TabControl1.InsertItem(2, _T("Tab Page 3"));
	TabControl1.InsertItem(3, _T("Tab Page 4"));
	TabControl1.InsertItem(4, _T("Tab Page 5"));

	SplitButton1.SetDropDownMenu(IDR_MENU1, 0);

	ProgressBar1.SetPos(75);
}

// CMFCVirtualUIDlg message handlers

BOOL CMFCVirtualUIDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	InitControls();

	m_VirtualUI = new VirtualUI();
	m_VirtualUI->StdDialogs(true);
	m_VirtualUI->Start();
	m_VirtualUI->OnBrowserResize = BrowserResize;
	m_VirtualUI->OnGetUploadDir = GetUploadDir;
	m_VirtualUI->OnDownloadEnd = DownloadEnd;

	CString params;
	LPWSTR *szArglist;
	int nArgs;
	int i;
	szArglist = CommandLineToArgvW(GetCommandLineW(), &nArgs);
	if (szArglist != NULL && nArgs > 0) {
		CString p;
		params = "Params:\r\n------------------------------\r\n";
		for (i = 0; i < nArgs; i++) {
			p.Format(_T("[%d]: "), i);
			params.Append(p);
			params.Append(szArglist[i]);
			params.Append(_T("\r\n"));
		}
		params.Append(_T("\r\n"));
	}
	LocalFree(szArglist);

	CString info;
	info.Format(_T("Some BrowserInfo values:\r\n------------------------------\r\nScreenWidth: %d\r\nScreenHeight: %d\r\nBrowserWidth: %d\r\nBrowserHeight: %d\r\nIPAddress: %s\r\nLocation: %s\r\nUniqueBrowserId: %s\r\nUserAgent: %s\r\n"),
					m_VirtualUI->BrowserInfo()->ScreenWidth(),
					m_VirtualUI->BrowserInfo()->ScreenHeight(),
					m_VirtualUI->BrowserInfo()->BrowserWidth(),
					m_VirtualUI->BrowserInfo()->BrowserHeight(),
					m_VirtualUI->BrowserInfo()->IPAddress().c_str(),
					m_VirtualUI->BrowserInfo()->Location().c_str(),
					m_VirtualUI->BrowserInfo()->UniqueBrowserId().c_str(),
					m_VirtualUI->BrowserInfo()->UserAgent().c_str());
	EditInfo.SetWindowText(params + info);
	EditInfo.ShowScrollBar(SB_HORZ);
	EditInfo.ShowScrollBar(SB_VERT);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMFCVirtualUIDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	CDialogEx::OnSysCommand(nID, lParam);
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFCVirtualUIDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFCVirtualUIDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMFCVirtualUIDlg::OnBnClickedButton1()
{
	CString text;
	Edit1.GetWindowText(text);
	
	ListBox1.AddString(text);
	Combo1.AddString(text);
	Combo1.SetCurSel(Combo1.GetCount() - 1);
}

void CMFCVirtualUIDlg::OnCbnSelchangeCombo2()
{
	ListControl1.SetView(ComboLCView.GetCurSel());
}

void CMFCVirtualUIDlg::OnBnClickedButton2()
{
	CFileDialog* fileDlg;
	fileDlg = new CFileDialog(TRUE);
	if (fileDlg->DoModal() == IDOK) {
		CString m_strPathname = fileDlg->GetPathName();
		MessageBox(m_strPathname, L"Filename");
	}
	fileDlg = NULL;
}

void CMFCVirtualUIDlg::OnBnClickedButton3()
{
	CFileDialog* fileDlg;
	fileDlg = new CFileDialog(FALSE);
	if (fileDlg->DoModal() == IDOK) {
		CString m_strPathname = fileDlg->GetPathName();
		MessageBox(m_strPathname, L"Filename");
	}
	fileDlg = NULL;
}

void CMFCVirtualUIDlg::OnBnClickedButton4()
{
	TCHAR path[MAX_PATH];
	GetModuleFileName(GetModuleHandle(NULL), path, MAX_PATH);
	m_VirtualUI->DownloadFile(path);
} 


void CMFCVirtualUIDlg::OnBnClickedButton5()
{
	TCHAR path[MAX_PATH];
	GetModuleFileName(GetModuleHandle(NULL), path, MAX_PATH);
	std::wstring wPath = path;
	m_VirtualUI->AllowExecute(wPath);

	CStringA strA(path);
	strA.Append(" param1 /param2 /param3=value3");
	LPCSTR lPath = strA;
	WinExec(lPath, SW_SHOWNORMAL);

	// Another method:
	//CString str(path);
	//CString strParameters("param1 /param2 /param3=value3");
	//_tspawnl(_P_NOWAIT, str, strParameters, NULL);
}


void CMFCVirtualUIDlg::OnBnClickedButton6()
{
	TCHAR path[MAX_PATH];
	GetModuleFileName(GetModuleHandle(NULL), path, MAX_PATH);
	PathRemoveFileSpec(path);
	
	std::wstring pdf = path;
	pdf.append(L"\\test.pdf");
	m_VirtualUI->PrintPdf(pdf);
}


void CMFCVirtualUIDlg::OnBnClickedButton7()
{
	std::wstring url = L"http://www.cybelesoft.com";
	std::wstring caption = L"Go to cybelesoft.com";
	m_VirtualUI->OpenLinkDlg(url, caption);
}


void CMFCVirtualUIDlg::OnLvnItemchangedList3(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	if (m_JSObject == NULL) {
		m_JSObject = new JSObject(L"People");
		m_JSObject->Properties()->Add(_T("Name"));
		m_JSObject->Properties()->Add(_T("Age"));
		m_JSObject->Properties()->Add(_T("City"));
		m_JSObject->ApplyModel();
	}
	
	BSTR value = ListControl1.GetItemText(pNMLV->iItem, 0).AllocSysString();
	m_JSObject->Properties()->Item(_T("Name"))->put_AsString(value);
	SysFreeString(value);

	value = ListControl1.GetItemText(pNMLV->iItem, 1).AllocSysString();
	m_JSObject->Properties()->Item(_T("Age"))->put_AsString(value);
	SysFreeString(value);

	value = ListControl1.GetItemText(pNMLV->iItem, 2).AllocSysString();
	m_JSObject->Properties()->Item(_T("City"))->put_AsString(value);
	SysFreeString(value);

	*pResult = 0;
}

void CMFCVirtualUIDlg::OnBnClickedButton8()
{
	m_VirtualUI->TakeScreenshot(this->m_hWnd, L".\\screenshot.png");
}
