#pragma once

#include "rpc.h"
#include "rpcndr.h"
#include <string>

#ifndef COM_NO_WINDOWS_H
#include "windows.h"
#include "ole2.h"
#endif /*COM_NO_WINDOWS_H*/

#pragma comment(lib,"Advapi32")
#pragma comment(lib,"OleAut32")

/*
* *********************************************************************************************
*  Thinfinity_TLB translation
* *********************************************************************************************
*/

/* Forward Declarations */ 

typedef interface IVirtualUI IVirtualUI;
typedef interface IBrowserInfo IBrowserInfo;
typedef interface IDevServer IDevServer;
typedef interface IClientSettings IClientSettings;
typedef interface IJSValue IJSValue;
typedef interface IJSNamedValue IJSNamedValue;
typedef interface IJSObject IJSObject;
typedef interface IJSObjects IJSObjects;
typedef interface IJSProperty IJSProperty;
typedef interface IJSProperties IJSProperties;
typedef interface IJSArgument IJSArgument;
typedef interface IJSArguments IJSArguments;
typedef interface IJSMethod IJSMethod;
typedef interface IJSMethods IJSMethods;
typedef interface IJSEvent IJSEvent;
typedef interface IJSEvents IJSEvents;
typedef interface IJSBinding IJSBinding;
typedef interface IJSCallback IJSCallback;
typedef interface IEvents IEvents;
typedef interface IJSObjectEvents IJSObjectEvents;

typedef class VirtualUI VirtualUI;
typedef class JSObject JSObject;
typedef class CJSProperties CJSProperties;
typedef class CJSMethods CJSMethods;
typedef class CJSEvents CJSEvents;
typedef class CJSObjects CJSObjects;

/* header files for imported files */
#include "ocidl.h"

#ifdef __cplusplus
extern "C" {
#endif
	enum  DECLSPEC_UUID("B81C7C6D-CDD4-4268-A769-C46EC04FD58B") IJSDataType
	{
		JSDT_NULL = 0,
		JSDT_STRING = 1,
		JSDT_INT = 2,
		JSDT_BOOL = 3,
		JSDT_FLOAT = 4,
		JSDT_JSON = 5
	};

	enum  DECLSPEC_UUID("0715C547-D231-4F69-9D25-44164C90DA88") Orientation
	{
		PORTRAIT = 0,
		LANDSCAPE = 1
	};

	enum  DECLSPEC_UUID("B1A699F2-F16C-49AA-93DD-1A056936AA87") MouseMoveGestureStyle
	{
		MM_STYLE_RELATIVE = 0,
		MM_STYLE_ABSOLUTE = 1
	};

	enum  DECLSPEC_UUID("EEC4FF42-7574-4250-8433-E14593AB7E7B") MouseMoveGestureAction
	{
		MM_ACTION_MOVE = 0,
		MM_ACTION_WHEEL = 1
	};

	extern RPC_IF_HANDLE __MIDL_itf_Thinfinity2EVirtualUI_0000_0000_v0_0_c_ifspec;
	extern RPC_IF_HANDLE __MIDL_itf_Thinfinity2EVirtualUI_0000_0000_v0_0_s_ifspec;

	/* interface IVirtualUI */
	/* [object][oleautomation][dual][helpstring][uuid] */

	EXTERN_C const IID IID_IVirtualUI;

	MIDL_INTERFACE("4B85F81B-72A2-4FCD-9A6B-9CAC24B7A511")
	IVirtualUI : public IDispatch
	{
	public:
		virtual /* [id] */ HRESULT __stdcall Start(
			/* [in] */ long Timeout,
			/* [retval][out] */ VARIANT_BOOL *OutRetVal) = 0;

		virtual /* [id] */ HRESULT __stdcall Stop(void) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_Active(
			/* [retval][out] */ VARIANT_BOOL *Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_Enabled(
			/* [retval][out] */ VARIANT_BOOL *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_Enabled(
			/* [in] */ VARIANT_BOOL Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_DevMode(
			/* [retval][out] */ VARIANT_BOOL *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_DevMode(
			/* [in] */ VARIANT_BOOL Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_StdDialogs(
			/* [retval][out] */ VARIANT_BOOL *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_StdDialogs(
			/* [in] */ VARIANT_BOOL Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_BrowserInfo(
			/* [retval][out] */ IBrowserInfo **Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_DevServer(
			/* [retval][out] */ IDevServer **Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_ClientSettings(
			/* [retval][out] */ IClientSettings **Value) = 0;

		virtual /* [id] */ HRESULT __stdcall DownloadFile(
			/* [in] */ BSTR LocalFilename,
			/* [in] */ BSTR RemoteFilename,
			/* [in] */ BSTR MimeType) = 0;

		virtual /* [id] */ HRESULT __stdcall PrintPdf(
			/* [in] */ BSTR AFileName) = 0;

		virtual /* [id] */ HRESULT __stdcall OpenLinkDlg(
			/* [in] */ BSTR url,
			/* [in] */ BSTR caption) = 0;

		virtual /* [id] */ HRESULT __stdcall SendMessage(
			/* [in] */ BSTR Data) = 0;

		virtual /* [id] */ HRESULT __stdcall AllowExecute(
			/* [in] */ BSTR Filename) = 0;

		virtual /* [id] */ HRESULT __stdcall SetImageQualityByWnd(
			/* [in] */ long Wnd,
			/* [in] */ BSTR Class,
			/* [in] */ long Quality) = 0;

		virtual /* [id] */ HRESULT __stdcall Uploadfile(
			/* [in] */ BSTR ServerDirectory) = 0;

		virtual /* [id] */ HRESULT __stdcall TakeScreenshot(
			/* [in] */ long Wnd,
			/* [in] */ BSTR FileName,
			/* [retval][out] */ VARIANT_BOOL *OutRetVal) = 0;
	};

	/* interface IBrowserInfo */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IBrowserInfo;

	MIDL_INTERFACE("4D9F5347-460B-4275-BDF2-F2738E7F6757")
	IBrowserInfo : public IDispatch
	{
	public:
		virtual /* [id][propget] */ HRESULT __stdcall get_ViewWidth(
			/* [retval][out] */ long *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_ViewWidth(
			/* [in] */ long Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_ViewHeight(
			/* [retval][out] */ long *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_ViewHeight(
			/* [in] */ long Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_BrowserWidth(
			/* [retval][out] */ long *Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_BrowserHeight(
			/* [retval][out] */ long *Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_ScreenWidth(
			/* [retval][out] */ long *Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_ScreenHeight(
			/* [retval][out] */ long *Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_Username(
			/* [retval][out] */ BSTR *Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_IPAddress(
			/* [retval][out] */ BSTR *Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_UserAgent(
			/* [retval][out] */ BSTR *Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_ScreenResolution(
			/* [retval][out] */ long *Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_Orientation(
		/* [retval][out] */ enum Orientation *Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_UniqueBrowserId(
			/* [retval][out] */ BSTR *Value) = 0;

		virtual /* [id] */ HRESULT __stdcall GetCookie(
			/* [in] */ BSTR Name,
			/* [retval][out] */ BSTR *Value) = 0;

		virtual /* [id] */ HRESULT __stdcall SetCookie(
			/* [in] */ BSTR Name,
			/* [in] */ BSTR Value,
			/* [in] */ BSTR Expires) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_Location(
			/* [retval][out] */ BSTR *Value) = 0;
	};

	/* interface IDevServer */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IDevServer;

	MIDL_INTERFACE("B3EAC0CA-D7AB-4AB1-9E24-84A63C8C3F80")
	IDevServer : public IDispatch
	{
	public:
		virtual /* [id][propget] */ HRESULT __stdcall get_Enabled(
			/* [retval][out] */ VARIANT_BOOL *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_Enabled(
			/* [in] */ VARIANT_BOOL Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_Port(
			/* [retval][out] */ long *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_Port(
			/* [in] */ long Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_StartBrowser(
			/* [retval][out] */ VARIANT_BOOL *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_StartBrowser(
			/* [in] */ VARIANT_BOOL Value) = 0;
	};

	/* interface IClientSettings */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IClientSettings;

	MIDL_INTERFACE("439624CA-ED33-47BE-9211-91290F29584A")
	IClientSettings : public IDispatch
	{
	public:
		virtual /* [id][propget] */ HRESULT __stdcall get_MouseMoveGestureStyle(
		/* [retval][out] */ enum MouseMoveGestureStyle *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_MouseMoveGestureStyle(
		/* [in] */ enum MouseMoveGestureStyle Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_MouseMoveGestureAction(
		/* [retval][out] */ enum MouseMoveGestureAction *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_MouseMoveGestureAction(
		/* [in] */ enum MouseMoveGestureAction Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_CursorVisible(
			/* [retval][out] */ VARIANT_BOOL *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_CursorVisible(
			/* [in] */ VARIANT_BOOL Value) = 0;
	};

	/* interface IJSValue */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IJSValue;

	MIDL_INTERFACE("6DE2E6A0-3C3A-47DC-9A93-928135EDAC90")
	IJSValue : public IDispatch
	{
	public:
		virtual /* [id][propget] */ HRESULT __stdcall get_DataType(
		/* [retval][out] */ enum IJSDataType *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_DataType(
		/* [in] */ enum IJSDataType Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_RawValue(
			/* [retval][out] */ VARIANT *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_RawValue(
			/* [in] */ VARIANT Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_AsString(
			/* [retval][out] */ BSTR *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_AsString(
			/* [in] */ BSTR Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_AsInt(
			/* [retval][out] */ long *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_AsInt(
			/* [in] */ long Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_AsBool(
			/* [retval][out] */ VARIANT_BOOL *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_AsBool(
			/* [in] */ VARIANT_BOOL Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_AsFloat(
			/* [retval][out] */ float *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_AsFloat(
			/* [in] */ float Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_AsJSON(
			/* [retval][out] */ BSTR *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_AsJSON(
			/* [in] */ BSTR Value) = 0;
	};

	/* interface IJSNamedValue */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IJSNamedValue;

	MIDL_INTERFACE("E492419B-00AC-4A91-9AE9-9A82B07E89AE")
	IJSNamedValue : public IJSValue
	{
	public:
		virtual /* [id][propget] */ HRESULT __stdcall get_Name(
			/* [retval][out] */ BSTR *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_Name(
			/* [in] */ BSTR Value) = 0;
	};

	/* interface IJSObject */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IJSObject;

	MIDL_INTERFACE("59342310-79A7-4B14-8B63-6DF05609AE30")
	IJSObject : public IDispatch
	{
	public:
		virtual /* [id][propget] */ HRESULT __stdcall get_Id(
			/* [retval][out] */ BSTR *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_Id(
			/* [in] */ BSTR Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_Properties(
			/* [retval][out] */ IJSProperties **Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_Methods(
			/* [retval][out] */ IJSMethods **Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_Events(
			/* [retval][out] */ IJSEvents **Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_Objects(
			/* [retval][out] */ IJSObjects **Value) = 0;

		virtual /* [id] */ HRESULT __stdcall FireEvent(
			/* [in] */ BSTR Name,
			/* [in] */ IJSArguments *Arguments) = 0;

		virtual /* [id] */ HRESULT __stdcall ApplyChanges(void) = 0;

		virtual /* [id] */ HRESULT __stdcall ApplyModel(void) = 0;
	};

	/* interface IJSObjects */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IJSObjects;

	MIDL_INTERFACE("C2406011-568E-4EAC-B95C-EF29E4806B86")
	IJSObjects : public IDispatch
	{
	public:
		virtual /* [id][propget] */ HRESULT __stdcall get_Count(
			/* [retval][out] */ long *Value) = 0;

		virtual /* [defaultcollelem][id][propget] */ HRESULT __stdcall get_Item(
			/* [in] */ VARIANT Index,
			/* [retval][out] */ IJSObject **Value) = 0;

		virtual /* [id] */ HRESULT __stdcall Clear(void) = 0;

		virtual /* [id] */ HRESULT __stdcall Add(
			/* [in] */ BSTR Id,
			/* [retval][out] */ IJSObject **Value) = 0;

		virtual /* [id] */ HRESULT __stdcall Remove(
			/* [in] */ IJSObject *Item) = 0;
	};

	/* interface IJSProperty */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IJSProperty;

	MIDL_INTERFACE("1F95C0E9-E7BF-48C9-AA35-88AD0149109B")
	IJSProperty : public IJSNamedValue
	{
	public:
		virtual /* [id][propget] */ HRESULT __stdcall get_ReadOnly(
			/* [retval][out] */ VARIANT_BOOL *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_ReadOnly(
			/* [in] */ VARIANT_BOOL Value) = 0;

		virtual /* [id] */ HRESULT __stdcall OnGet(
			/* [in] */ IJSBinding *Binding,
			/* [retval][out] */ IJSProperty **OutRetVal) = 0;

		virtual /* [id] */ HRESULT __stdcall OnSet(
			/* [in] */ IJSBinding *Binding,
			/* [retval][out] */ IJSProperty **OutRetVal) = 0;
	};

	/* interface IJSProperties */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IJSProperties;

	MIDL_INTERFACE("FCBB688F-8FB2-42C1-86FC-0AAF3B2A500C")
	IJSProperties : public IDispatch
	{
	public:
		virtual /* [id][propget] */ HRESULT __stdcall get_Count(
			/* [retval][out] */ long *Value) = 0;

		virtual /* [defaultcollelem][id][propget] */ HRESULT __stdcall get_Item(
			/* [in] */ VARIANT Index,
			/* [retval][out] */ IJSProperty **Value) = 0;

		virtual /* [id] */ HRESULT __stdcall Clear(void) = 0;

		virtual /* [id] */ HRESULT __stdcall Add(
			/* [in] */ BSTR Name,
			/* [retval][out] */ IJSProperty **OutRetVal) = 0;

		virtual /* [id] */ HRESULT __stdcall Remove(
			/* [in] */ IJSProperty *Item) = 0;
	};

	/* interface IJSArgument */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IJSArgument;

	MIDL_INTERFACE("8F8C4462-D7B5-4696-BAD5-16DFAA6E2601")
	IJSArgument : public IJSNamedValue
	{
	public:
	};

	/* interface IJSArguments */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IJSArguments;

	MIDL_INTERFACE("FC097EF5-6D8A-4C80-A2AD-382FDC75E901")
	IJSArguments : public IDispatch
	{
	public:
		virtual /* [id][propget] */ HRESULT __stdcall get_Count(
			/* [retval][out] */ long *Value) = 0;

		virtual /* [defaultcollelem][id][propget] */ HRESULT __stdcall get_Item(
			/* [in] */ VARIANT Index,
			/* [retval][out] */ IJSArgument **Value) = 0;

		virtual /* [id] */ HRESULT __stdcall Clear(void) = 0;

		virtual /* [id] */ HRESULT __stdcall Add(
			/* [in] */ BSTR Name,
			/* [retval][out] */ IJSArgument **OutRetVal) = 0;

		virtual /* [id] */ HRESULT __stdcall Remove(
			/* [in] */ IJSArgument *Item) = 0;
	};

	/* interface IJSMethod */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IJSMethod;

	MIDL_INTERFACE("C45D6A8F-AD4A-47BB-AC3A-C125D6D5D27E")
	IJSMethod : public IDispatch
	{
	public:
		virtual /* [id][propget] */ HRESULT __stdcall get_Name(
			/* [retval][out] */ BSTR *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_Name(
			/* [in] */ BSTR Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_Arguments(
			/* [retval][out] */ IJSArguments **Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_ReturnValue(
			/* [retval][out] */ IJSValue **Value) = 0;

		virtual /* [id] */ HRESULT __stdcall AddArgument(
			/* [in] */ BSTR Name,
		/* [in] */ enum IJSDataType DataType,
			/* [retval][out] */ IJSMethod **OutRetVal) = 0;

		virtual /* [id] */ HRESULT __stdcall OnCall(
			/* [in] */ IJSCallback *Callback,
			/* [retval][out] */ IJSMethod **OutRetVal) = 0;
	};

	/* interface IJSMethods */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IJSMethods;

	MIDL_INTERFACE("E4CB461F-586E-4121-ABD7-345B87BC423A")
	IJSMethods : public IDispatch
	{
	public:
		virtual /* [id][propget] */ HRESULT __stdcall get_Count(
			/* [retval][out] */ long *Value) = 0;

		virtual /* [defaultcollelem][id][propget] */ HRESULT __stdcall get_Item(
			/* [in] */ VARIANT Index,
			/* [retval][out] */ IJSMethod **Value) = 0;

		virtual /* [id] */ HRESULT __stdcall Clear(void) = 0;

		virtual /* [id] */ HRESULT __stdcall Add(
			/* [in] */ BSTR Name,
			/* [retval][out] */ IJSMethod **OutRetVal) = 0;

		virtual /* [id] */ HRESULT __stdcall Remove(
			/* [in] */ IJSMethod *Item) = 0;
	};

	/* interface IJSEvent */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IJSEvent;

	MIDL_INTERFACE("8B66EACD-9619-43CF-9196-DCDA17F5500E")
	IJSEvent : public IDispatch
	{
	public:
		virtual /* [id][propget] */ HRESULT __stdcall get_Name(
			/* [retval][out] */ BSTR *Value) = 0;

		virtual /* [id][propput] */ HRESULT __stdcall put_Name(
			/* [in] */ BSTR Value) = 0;

		virtual /* [id][propget] */ HRESULT __stdcall get_Arguments(
			/* [retval][out] */ IJSArguments **Value) = 0;

		virtual /* [id] */ HRESULT __stdcall AddArgument(
			/* [in] */ BSTR Name,
		/* [in] */ enum IJSDataType DataType,
			/* [retval][out] */ IJSEvent **OutRetVal) = 0;

		virtual /* [id] */ HRESULT __stdcall ArgumentAsNull(
			/* [in] */ VARIANT Index,
			/* [retval][out] */ IJSEvent **OutRetVal) = 0;

		virtual /* [id] */ HRESULT __stdcall ArgumentAsString(
			/* [in] */ VARIANT Index,
			/* [in] */ BSTR Value,
			/* [retval][out] */ IJSEvent **OutRetVal) = 0;

		virtual /* [id] */ HRESULT __stdcall ArgumentAsInt(
			/* [in] */ VARIANT Index,
			/* [in] */ long Value,
			/* [retval][out] */ IJSEvent **OutRetVal) = 0;

		virtual /* [id] */ HRESULT __stdcall ArgumentAsBool(
			/* [in] */ VARIANT Index,
			/* [in] */ VARIANT_BOOL Value,
			/* [retval][out] */ IJSEvent **OutRetVal) = 0;

		virtual /* [id] */ HRESULT __stdcall ArgumentAsFloat(
			/* [in] */ VARIANT Index,
			/* [in] */ float Value,
			/* [retval][out] */ IJSEvent **OutRetVal) = 0;

		virtual /* [id] */ HRESULT __stdcall ArgumentAsJSON(
			/* [in] */ VARIANT Index,
			/* [in] */ BSTR Value,
			/* [retval][out] */ IJSEvent **OutRetVal) = 0;

		virtual /* [id] */ HRESULT __stdcall Fire(void) = 0;
	};

	/* interface IJSEvents */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IJSEvents;

	MIDL_INTERFACE("6AE952B3-B6DA-4C81-80FF-D0A162E11D02")
	IJSEvents : public IDispatch
	{
	public:
		virtual /* [id][propget] */ HRESULT __stdcall get_Count(
			/* [retval][out] */ long *Value) = 0;

		virtual /* [defaultcollelem][id][propget] */ HRESULT __stdcall get_Item(
			/* [in] */ VARIANT Index,
			/* [retval][out] */ IJSEvent **Value) = 0;

		virtual /* [id] */ HRESULT __stdcall Clear(void) = 0;

		virtual /* [id] */ HRESULT __stdcall Add(
			/* [in] */ BSTR Name,
			/* [retval][out] */ IJSEvent **OutRetVal) = 0;

		virtual /* [id] */ HRESULT __stdcall Remove(
			/* [in] */ IJSEvent *Item) = 0;
	};

	/* interface IJSBinding */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IJSBinding;

	MIDL_INTERFACE("ACFC2953-37F1-479E-B405-D0BB75E156E6")
	IJSBinding : public IDispatch
	{
	public:
		virtual /* [id] */ HRESULT __stdcall Set(
			/* [in] */ IJSObject *Parent,
			/* [in] */ IJSProperty *Prop) = 0;
	};

	/* interface IJSCallback */
	/* [object][oleautomation][dual][uuid] */

	EXTERN_C const IID IID_IJSCallback;

	MIDL_INTERFACE("ADD570A0-491A-4E40-8120-57B4D1245FD3")
	IJSCallback : public IDispatch
	{
	public:
		virtual /* [id] */ HRESULT __stdcall Callback(
			/* [in] */ IJSObject *Parent,
			/* [in] */ IJSMethod *Method) = 0;
	};

	EXTERN_C const IID IID_IEvents;

	MIDL_INTERFACE("1C5700BC-2317-4062-B614-0A4E286CFE68")
	IEvents : public IDispatch
	{
	public:
		virtual /* [id] */ HRESULT __stdcall OnGetUploadDir(
			/* [in, out] */ BSTR *Directory,
			/* [in, out] */ VARIANT_BOOL* Handled) = 0;

		virtual /* [id] */ HRESULT __stdcall OnBrowserResize(
			/* [in, out] */ long* Width,
			/* [in, out] */ long* Height,
			/* [in, out] */ VARIANT_BOOL* ResizeMaximized) = 0;

		virtual /* [id] */ HRESULT __stdcall OnClose(void) = 0;

		virtual /* [id] */ HRESULT __stdcall OnReceiveMessage(
			/* [in] */ BSTR *Data) = 0;

		virtual /* [id] */ HRESULT __stdcall OnDownloadEnd(
			/* [in] */ BSTR *Filename) = 0;
	};

	EXTERN_C const IID IID_IJSObjectEvents;

	MIDL_INTERFACE("A3D640E8-CD18-4196-A1A2-C87C82B0F88B")
	IJSObjectEvents : public IDispatch
	{
	public:
		virtual /* [id] */ HRESULT __stdcall OnExecuteMethod(
			/* [in] */ IJSObject *Caller,
			/* [in] */ IJSMethod *Method) = 0;

		virtual /* [id] */ HRESULT __stdcall OnPropertyChange(
			/* [in] */ IJSObject *Caller,
			/* [in] */ IJSProperty *Prop) = 0;
	};

	/* Additional Prototypes for ALL interfaces */

	unsigned long             __RPC_USER  BSTR_UserSize(unsigned long *, unsigned long, BSTR *);
	unsigned char * __RPC_USER  BSTR_UserMarshal(unsigned long *, unsigned char *, BSTR *);
	unsigned char * __RPC_USER  BSTR_UserUnmarshal(unsigned long *, unsigned char *, BSTR *);
	void                      __RPC_USER  BSTR_UserFree(unsigned long *, BSTR *);

	unsigned long             __RPC_USER  VARIANT_UserSize(unsigned long *, unsigned long, VARIANT *);
	unsigned char * __RPC_USER  VARIANT_UserMarshal(unsigned long *, unsigned char *, VARIANT *);
	unsigned char * __RPC_USER  VARIANT_UserUnmarshal(unsigned long *, unsigned char *, VARIANT *);
	void                      __RPC_USER  VARIANT_UserFree(unsigned long *, VARIANT *);

#ifdef __cplusplus
}
#endif




/// <summary>
/// Allows to set some client settings.
/// </summary>
class CClientSettings : public IClientSettings {
private:
	IVirtualUI *m_VirtualUI;
	ULONG m_refcount;
	IClientSettings *m_ClientSettings;

	HRESULT __stdcall GetTypeInfo(UINT Index, LCID LocaleID, ITypeInfo FAR* FAR* TypeInfo);
	HRESULT __stdcall GetTypeInfoCount(UINT *Count);
	HRESULT __stdcall GetIDsOfNames(REFIID IID, LPOLESTR *Names, UINT NameCount, LCID LocaleID, DISPID *DispIDs);
	HRESULT __stdcall Invoke(DISPID DispID, REFIID IID, LCID LocaleID, WORD Flags, DISPPARAMS *Params, VARIANT *VarResult, EXCEPINFO *ExcepInfo, UINT *ArgErr);
	ULONG __stdcall AddRef();
	ULONG __stdcall Release();
	HRESULT __stdcall QueryInterface(REFIID riid, void **ppvObject);

public:
	CClientSettings(IVirtualUI *virtualUI);
	~CClientSettings();

	HRESULT __stdcall get_MouseMoveGestureStyle(enum MouseMoveGestureStyle *Value);
	HRESULT __stdcall put_MouseMoveGestureStyle(enum MouseMoveGestureStyle Value);
	HRESULT __stdcall get_MouseMoveGestureAction(enum MouseMoveGestureAction *Value);
	HRESULT __stdcall put_MouseMoveGestureAction(enum MouseMoveGestureAction Value);
	HRESULT __stdcall get_CursorVisible(VARIANT_BOOL *Value);
	HRESULT __stdcall put_CursorVisible(VARIANT_BOOL Value);

	/// <summary>
	/// Gets the MouseMoveGestureStyle value
	MouseMoveGestureStyle MouseMoveGestStyle();

	/// <summary>
	/// Valid for touch devices. Specifies whether the mouse pointer
	/// is shown and acts on the exact spot of the finger touch
	/// (absolute) or its position is managed relatively to the
	/// movement of the finger touch (relative).
	/// </summary>
	void MouseMoveGestStyle(MouseMoveGestureStyle value);

	/// <summary>
	/// Gets the MouseMoveGestureAction value
	/// </summary>
	MouseMoveGestureAction MouseMoveGestAction();

	/// <summary>
	/// Specifies whether the &quot;mouse move&quot; simulation on a
	/// touch device is interpreted as a mouse move or as a mouse
	/// wheel.
	/// </summary>
	void MouseMoveGestAction(MouseMoveGestureAction value);

	/// <summary>
	/// Gets the the mouse pointer state.
	/// </summary>
	bool CursorVisible();

	/// <summary>
	/// Hides/shows the mouse pointer.
	/// </summary>
	void CursorVisible(bool value);
};


/// <summary>
/// Contains information regarding the end-user's screen, web
/// browser, the window containing VirtualUI Viewer and VirtualUI
/// Viewer itself. The VirtualUI Viewer tuns inside an HTML DIV
/// element contained in a frame o browser window on the
/// end-user's application page. 
/// </summary>                                                   
class CBrowserInfo : public IBrowserInfo {
private:
	IVirtualUI *m_VirtualUI;
	ULONG m_refcount;
	IBrowserInfo *m_BrowserInfo;

	HRESULT __stdcall GetTypeInfo(UINT Index, LCID LocaleID, ITypeInfo FAR* FAR* TypeInfo);
	HRESULT __stdcall GetTypeInfoCount(UINT *Count);
	HRESULT __stdcall GetIDsOfNames(REFIID IID, LPOLESTR *Names, UINT NameCount, LCID LocaleID, DISPID *DispIDs);
	HRESULT __stdcall Invoke(DISPID DispID, REFIID IID, LCID LocaleID, WORD Flags, DISPPARAMS *Params, VARIANT *VarResult, EXCEPINFO *ExcepInfo, UINT *ArgErr);
	ULONG __stdcall AddRef();
	ULONG __stdcall Release();
	HRESULT __stdcall QueryInterface(REFIID riid, void **ppvObject);

public:
	CBrowserInfo(IVirtualUI *virtualUI);
	~CBrowserInfo();

	HRESULT __stdcall get_ViewWidth(long *Value);
	HRESULT __stdcall put_ViewWidth(long Value);
	HRESULT __stdcall get_ViewHeight(long *Value);
	HRESULT __stdcall put_ViewHeight(long Value);
	HRESULT __stdcall get_BrowserWidth(long *Value);
	HRESULT __stdcall get_BrowserHeight(long *Value);
	HRESULT __stdcall get_ScreenWidth(long *Value);
	HRESULT __stdcall get_ScreenHeight(long *Value);
	HRESULT __stdcall get_Username(BSTR *Value);
	HRESULT __stdcall get_IPAddress(BSTR *Value);
	HRESULT __stdcall get_UserAgent(BSTR *Value);
	HRESULT __stdcall get_ScreenResolution(long *Value);
	HRESULT __stdcall get_Orientation(enum Orientation *Value);
	HRESULT __stdcall get_UniqueBrowserId(BSTR *Value);
	HRESULT __stdcall GetCookie(BSTR Name, BSTR *Value);
	HRESULT __stdcall SetCookie(BSTR Name, BSTR Value, BSTR Expires);
	HRESULT __stdcall get_Location(BSTR *Value);

	/// <summary>
	/// Returns the width of the VirtualUI Viewer. 
	/// </summary>                                  
	int ViewWidth();
	
	/// <summary>
	/// Sets the width of the VirtualUI Viewer. 
	/// </summary>                                  
	void ViewWidth(int value);

	/// <summary>
	/// Returns the height of the VirtualUI Viewer. 
	/// </summary>                                   
	int ViewHeight();
	
	/// <summary>
	/// Sets the height of the VirtualUI Viewer. 
	/// </summary>                                   
	void ViewHeight(int value);

	/// <value>
	/// Returns the width of the HTML element containing the
	/// VirtualUI Viewer. 
	/// </value>                                             
	int BrowserWidth();

	/// <summary>
	/// \Returns the height of the HTML element containing the
	/// VirtualUI Viewer. 
	/// </summary>                                            
	int BrowserHeight();

	/// <summary>
	/// Returns the width of the end-user's monitor screen. 
	/// </summary>                                           
	int ScreenWidth();

	/// <summary>
	/// \Returns the height of the end-user's monitor screen. 
	/// </summary>                                            
	int ScreenHeight();

	/// <summary>
	/// Returns the logged-on Username. 
	/// </summary>                       
    std::wstring Username();

	/// <summary>
	/// Returns the client's IP address. 
	/// </summary>                        
    std::wstring IPAddress();

	/// <summary>
	/// Returns the browser's User Agent string. 
	/// </summary>                                
    std::wstring UserAgent();

	/// <summary>
	/// UniqueBrowserId identifies an instance of a Web Browser. Each time
	/// an end-user opens the application from a different browser window,
	/// this ID will have a different value.
	/// </summary>                                
    std::wstring UniqueBrowserId();

	/// <summary>
	/// Returns the URL of the current application.
	/// </summary>                                
    std::wstring Location();

	/// <summary>
	/// \Returns the application screen resolution defined in the
	/// application profile. 
	/// </summary>                                               
	int ScreenResolution();

	/// <summary>
	/// \Returns the browser's orientation. 
	/// </summary>                          
	Orientation Orientation();
};


/// <summary>
/// Contains properties to manage the VirtualUI Development
/// Server as well as the access from the developer's web
/// browser. 
/// </summary>                                             
class CDevServer : public IDevServer
{
private:
	IVirtualUI *m_VirtualUI;
	ULONG m_refcount;
	IDevServer *m_DevServer;

	HRESULT __stdcall GetTypeInfo(UINT Index, LCID LocaleID, ITypeInfo FAR* FAR* TypeInfo);
	HRESULT __stdcall GetTypeInfoCount(UINT *Count);
	HRESULT __stdcall GetIDsOfNames(REFIID IID, LPOLESTR *Names, UINT NameCount, LCID LocaleID, DISPID *DispIDs);
	HRESULT __stdcall Invoke(DISPID DispID, REFIID IID, LCID LocaleID, WORD Flags, DISPPARAMS *Params, VARIANT *VarResult, EXCEPINFO *ExcepInfo, UINT *ArgErr);
	ULONG __stdcall AddRef();
	ULONG __stdcall Release();
	HRESULT __stdcall QueryInterface(REFIID riid, void **ppvObject);

public:
	CDevServer(IVirtualUI *virtualUI);
	~CDevServer();

	HRESULT __stdcall get_Enabled(VARIANT_BOOL *Value);
	HRESULT __stdcall put_Enabled(VARIANT_BOOL Value);
	HRESULT __stdcall get_Port(long *Value);
	HRESULT __stdcall put_Port(long Value);
	HRESULT __stdcall get_StartBrowser(VARIANT_BOOL *Value);
	HRESULT __stdcall put_StartBrowser(VARIANT_BOOL Value);

	/// <summary>
	///   Gets the Development Server state.
	/// </summary>
	bool Enabled();
	
	/// <summary>
	///   Enables/disables the Development Server.
	/// </summary>
	void Enabled(bool value);

	/// <summary>
	///   Gets the Development Server's TCP/IP listening port.
	/// </summary>
	int Port();

	/// <summary>
	///   Sets the Development Server's TCP/IP listening port.
	/// </summary>
	void Port(int value);

	/// <summary>
	/// Instructs VirtualUI whether start or not the local web
	/// browser upon VirtualUI activation.  
	/// </summary>                                            
	void StartBrowser(bool value);
};


class VirtualUILibrary {
protected:
	static HINSTANCE LibHandle;
    std::wstring GetDLLPath();
public:
	VirtualUILibrary();
};


class EventSinkHelper {
protected:
	int GetAsInteger(DISPPARAMS* args, int index);
	void SetInteger(DISPPARAMS* args, int index, int value);
	bool GetAsBoolean(DISPPARAMS* args, int index);
	void SetBoolean(DISPPARAMS* args, int index, bool value);
	VARIANT_BOOL GetAsVariantBool(DISPPARAMS* args, int index);
	void SetVariantBool(DISPPARAMS* args, int index, VARIANT_BOOL value);
    std::wstring GetAsString(DISPPARAMS* args, int index);
    void SetString(DISPPARAMS* args, int index, std::wstring value);
	BSTR GetAsBSTR(DISPPARAMS* args, int index);
	void SetBSTR(DISPPARAMS* args, int index, BSTR value);
	IDispatch* GetAsInterface(DISPPARAMS* args, int index);
};

class VirtualUISink : private EventSinkHelper, IEvents
{
private:
	VirtualUI* m_VirtualUI;
	ULONG m_refcount;
	IConnectionPoint* m_pIConnectionPoint;
	DWORD m_dwEventCookie;

	HRESULT __stdcall GetTypeInfo(UINT Index, LCID LocaleID, ITypeInfo FAR* FAR* TypeInfo);
	HRESULT __stdcall GetTypeInfoCount(UINT *Count);
	HRESULT __stdcall GetIDsOfNames(REFIID IID, LPOLESTR *Names, UINT NameCount, LCID LocaleID, DISPID *DispIDs);
	HRESULT __stdcall Invoke(DISPID DispID, REFIID IID, LCID LocaleID, WORD Flags, DISPPARAMS *Params, VARIANT *VarResult, EXCEPINFO *ExcepInfo, UINT *ArgErr);
	ULONG __stdcall AddRef();
	ULONG __stdcall Release();
	HRESULT __stdcall QueryInterface(REFIID riid, void **ppvObject);

	HRESULT __stdcall OnGetUploadDir(BSTR *Directory, VARIANT_BOOL* Handled);
	HRESULT __stdcall OnBrowserResize(long* Width, long* Height, VARIANT_BOOL* ResizeMaximized);
	HRESULT __stdcall OnClose(void);
	HRESULT __stdcall OnReceiveMessage(BSTR *Data);
	HRESULT __stdcall OnDownloadEnd(BSTR *Filename);
public:
	VirtualUISink(VirtualUI* virtualUI);
	~VirtualUISink();
};

class JSObjectSink : private EventSinkHelper, IJSObjectEvents
{
private:
	JSObject* m_JSObject;
	ULONG m_refcount;
	IConnectionPoint* m_pIConnectionPoint;
	DWORD m_dwEventCookie;

	HRESULT __stdcall GetTypeInfo(UINT Index, LCID LocaleID, ITypeInfo FAR* FAR* TypeInfo);
	HRESULT __stdcall GetTypeInfoCount(UINT *Count);
	HRESULT __stdcall GetIDsOfNames(REFIID IID, LPOLESTR *Names, UINT NameCount, LCID LocaleID, DISPID *DispIDs);
	HRESULT __stdcall Invoke(DISPID DispID, REFIID IID, LCID LocaleID, WORD Flags, DISPPARAMS *Params, VARIANT *VarResult, EXCEPINFO *ExcepInfo, UINT *ArgErr);
	ULONG __stdcall AddRef();
	ULONG __stdcall Release();
	HRESULT __stdcall QueryInterface(REFIID riid, void **ppvObject);

	HRESULT __stdcall OnExecuteMethod(IJSObject *Caller, IJSMethod *Method);
	HRESULT __stdcall OnPropertyChange(IJSObject *Caller, IJSProperty *Prop);
public:
	JSObjectSink(JSObject* jsObject);
	~JSObjectSink();
};


/// <summary>
/// Main class. Has methods, properties and events to allow the
/// activation and control the behavior of VirtualUI. 
/// </summary>                                                 
class VirtualUI : public VirtualUILibrary, IVirtualUI
{
private:
	ULONG m_refcount;

	IVirtualUI *m_VirtualUI;
	CClientSettings *m_ClientSettings;
	CBrowserInfo *m_BrowserInfo;
	CDevServer *m_DevServer;
	VirtualUISink* m_EventSink;

	HRESULT __stdcall GetTypeInfo(UINT Index, LCID LocaleID, ITypeInfo FAR* FAR* TypeInfo);
	HRESULT __stdcall GetTypeInfoCount(UINT *Count);
	HRESULT __stdcall GetIDsOfNames(REFIID IID, LPOLESTR *Names, UINT NameCount, LCID LocaleID, DISPID *DispIDs);
	HRESULT __stdcall Invoke(DISPID DispID, REFIID IID, LCID LocaleID, WORD Flags, DISPPARAMS *Params, VARIANT *VarResult, EXCEPINFO *ExcepInfo, UINT *ArgErr);
	ULONG __stdcall AddRef();
	ULONG __stdcall Release();

public:
    VirtualUI();
    ~VirtualUI();
	
	HRESULT __stdcall QueryInterface(REFIID riid, void **ppvObject);
	
	HRESULT __stdcall Start(long Timeout, VARIANT_BOOL *OutRetVal);
	HRESULT __stdcall get_Active(VARIANT_BOOL *Value);
	HRESULT __stdcall get_Enabled(VARIANT_BOOL *Value);
	HRESULT __stdcall put_Enabled(VARIANT_BOOL Value);
	HRESULT __stdcall get_DevMode(VARIANT_BOOL *Value);
	HRESULT __stdcall put_DevMode(VARIANT_BOOL Value);
	HRESULT __stdcall get_StdDialogs(VARIANT_BOOL *Value);
	HRESULT __stdcall put_StdDialogs(VARIANT_BOOL Value);
	HRESULT __stdcall get_BrowserInfo(IBrowserInfo **Value);
	HRESULT __stdcall get_DevServer(IDevServer **Value);
	HRESULT __stdcall get_ClientSettings(IClientSettings **Value);
	HRESULT __stdcall DownloadFile(BSTR LocalFilename, BSTR RemoteFilename, BSTR MimeType);
	HRESULT __stdcall PrintPdf(BSTR AFileName);
	HRESULT __stdcall OpenLinkDlg(BSTR url, BSTR caption);
	HRESULT __stdcall SendMessage(BSTR Data);
	HRESULT __stdcall AllowExecute(BSTR Filename);
	HRESULT __stdcall SetImageQualityByWnd(long Wnd, BSTR Class, long Quality);
	HRESULT __stdcall Uploadfile(BSTR ServerDirectory);
	HRESULT __stdcall TakeScreenshot(long Wnd, BSTR FileName, VARIANT_BOOL *OutRetVal);

	/// <summary>
	/// Starts the VirtualUI's activation process. Returns true if
	/// VirtualUI was fully activated or false if the timeout
	/// expired. The timeout is 60 seconds. 
	/// </summary>                                                
    bool Start();

	/// <summary>
	/// Starts the VirtualUI's activation process. Returns true if
	/// VirtualUI was fully activated or false if the passed timeout
	/// expired.
	/// </summary>
	/// <param name="Timeout">Maximum time, in seconds, until the
	///                       activation process is canceled.
	///                       Defaults to 60 seconds. </param>
	/// <remarks>
	/// To fully activate VirtualUI, the connection with the
	/// end-user's web browser must established within the time
	/// specified by Timeout parameter. 
	/// </remarks>
    bool Start(int Timeout);

	/// <summary>
	/// Deactivates VirtualUI, closing the connection with the
	/// end-user's web browser. 
	/// </summary>                                            
	HRESULT __stdcall Stop(void);
	
	/// <summary>
	/// Sends the specified file to the end-user's web browser for
	/// saving it in the remote machine.
	/// </summary>
	/// <param name="LocalFilename">Name of both the local and
	///                             remote file . </param>        
    void DownloadFile(std::wstring LocalFilename);

	/// <summary>
	/// Sends the specified file to the end-user's web browser for
	/// saving it in the remote machine.
	/// </summary>
	/// <param name="LocalFilename">Name of the local file to be
	///                             sent. </param>
	/// <param name="RemoteFilename">Name of the file in the remote
	///                              machine. </param>             
    void DownloadFile(std::wstring LocalFilename, std::wstring RemoteFilename);

	/// <summary>
	/// Sends the specified file to the end-user's web browser for
	/// saving it in the remote machine.
	/// </summary>
	/// <param name="LocalFilename">Name of the local file to be
	///                             sent. </param>
	/// <param name="RemoteFilename">Name of the file in the remote
	///                              machine. </param>             
	/// <param name="MimeType">content-type of the file. If specified,
	///                        the content will be handled by browser.
	///                        Leave blank to force download.</param>
    void DownloadFile(std::wstring LocalFilename, std::wstring RemoteFilename, std::wstring MimeType);

	/// <summary>
	/// Sends the specified PDF file to be shown on the end-user's
	/// web browser.
	/// </summary>
	/// <param name="AFileName">Name of the PDF file. </param>
	/// <remarks>
	/// PrintPDF is similar to DownloadFile, except that it downloads
	/// the file with a content-type: application/pdf. 
	/// </remarks>                                                   
    void PrintPdf(std::wstring FileName);

	/// <summary>
	///   Displays a popup with a button to open a web link.
	/// </summary>
	/// <param name="url">Link to open.</param>
	/// <param name="caption">Text to display in popup.</param>
    void OpenLinkDlg(std::wstring Url, std::wstring Caption);

	/// <summary>
	/// Sends a data string to the web browser.
	/// </summary>
	/// <remarks>
	/// This method is used to send custom data to the browser for
	/// custom purposes. 
	/// </remarks>                                                
    void SendMessage(std::wstring Data);

	/// <summary>
	/// Allows the execution of the passed application.
	/// </summary>
	/// <param name="Filename">regular expression specifying the
	///                        filename(s) of the applications
	///                        allowed to run. </param>
	/// <remarks>
	/// Under VirtualUI environment, only applications precompiled
	/// with VirtualUI SDK should be allowed to run. Applications not
	/// under VirtualUI control, cannot be controlled. 
	/// </remarks>                                                   
    void AllowExecute(std::wstring Filename);
	
	/// <summary>
	/// Allows to the the image quality for the specified window.
	/// </summary>
	/// <param name="Wnd">Window handle. </param>
	/// <param name="Class">Window classname. </param>
	/// <param name="Quality">Quality from 0 to 100. </param>    
    void SetImageQualityByWnd(long Wnd, std::wstring Classname, long Quality);

	/// <summary>
	///   Selects a file from client machine, and it's uploaded to
	///   ServerDirectory
	/// </summary>
	/// <param name="ServerDirectory">Destination directory in Server.</param>
    void Uploadfile(std::wstring ServerDirectory);

	/// <summary>
	///   Selects a file from client machine, and it's uploaded to VirtualUI
	///   public path.
	/// </summary>
	void Uploadfile();

	/// <summary>
	///   Takes a screenshot of a Window.
	/// </summary>
	/// <param name="Wnd">The Window to capture.</param>
	/// <param name="FileName">Full path of file to save screenshot.
	///                        Extensions allowed: jpg, bmp, png.</param>
	bool TakeScreenshot(HWND Wnd, std::wstring FileName);

	/// <summary>
	/// Returns the VirtualUI's state. 
	/// </summary>                      
	bool Active();

	/// <summary>
	/// Gets the VirtualUI state for the container application. 
	/// </summary>                                                
	bool Enabled();

	/// <summary>
	/// Enables/disables VirtualUI for the container application. 
	/// </summary>                                                
	void Enabled(bool value);

	/// <summary>
	/// Gets the development mode.
	/// </summary>
	bool DevMode();

	/// <summary>
	/// Sets the development mode.
	/// </summary>
	/// <remarks>
	/// When in development mode, applications executed under the
	/// IDE, connect to the Development Server, allowing the access
	/// to the application from the browser while in debugging. 
	/// </remarks>                                                 
	void DevMode(bool value);

	/// <summary>
	/// Gets the use of standard dialogs state.
	/// </summary>
	bool StdDialogs();

	/// <summary>
	/// Enables/disables the use of standard dialogs.
	/// </summary>
	/// <remarks>
	/// When set to false, the standard save, open and print dialogs
	/// are replaced by native browser ones, enabling you to extend
	/// the operations to the remote computer. 
	/// </remarks>                                                  
	void StdDialogs(bool value);

	/// <summary>
	/// Controls some working parameters on the client side. 
	/// </summary>                                           
	CClientSettings* ClientSettings();

	/// <summary>
	/// Contains information regarding the end-user's environment. 
	/// </summary>                                                 
	CBrowserInfo* BrowserInfo();
	
	/// <summary>
	/// Allows for managing the Development Server. 
	/// </summary>                                  
	CDevServer* DevServer();

	void(*OnBrowserResize)(int &Width, int &Height, bool &ResizeMaximized);
    void(*OnGetUploadDir)(std::wstring &Directory, bool &Handled);
	void(*OnClose)();
    void(*OnReceiveMessage)(std::wstring &Data);
    void(*OnDownloadEnd)(std::wstring &Filename);
};


/// <summary>
/// Represents a custom remotable object.
/// </summary>
/// <remarks>
/// JSObject allows you to define an object model that is
/// mirrored on the client side, and allows for an easy, powerful
/// and straight-forward way to connect the web browser client
/// application and the remoted Windows application.
///
/// JSObject can contain properties (IJSProperties), methods
/// (IJSMethods), events (IJSEvents) and children objects.
/// Changes to properties values are propagated in from server to
/// client and viceversa, keeping the data synchronized.
///
/// JSObject is defined as a model seen from the client
/// perspective. A method (IJSMethod) is called on the client
/// side and executed on the server side. An event (IJSEvent) is
/// called on the server side and raised on the client side.
/// </remarks>
class JSObject : public VirtualUILibrary, IJSObject
{
private:
	ULONG m_refcount;
	IJSObject* m_JSObject;
	JSObjectSink* m_EventSink;
	CJSProperties* m_JSProperties;
	CJSMethods* m_JSMethods;
	CJSEvents* m_JSEvents;
	CJSObjects* m_JSObjects;

	HRESULT __stdcall GetTypeInfo(UINT Index, LCID LocaleID, ITypeInfo FAR* FAR* TypeInfo);
	HRESULT __stdcall GetTypeInfoCount(UINT *Count);
	HRESULT __stdcall GetIDsOfNames(REFIID IID, LPOLESTR *Names, UINT NameCount, LCID LocaleID, DISPID *DispIDs);
	HRESULT __stdcall Invoke(DISPID DispID, REFIID IID, LCID LocaleID, WORD Flags, DISPPARAMS *Params, VARIANT *VarResult, EXCEPINFO *ExcepInfo, UINT *ArgErr);
	ULONG __stdcall AddRef();
	ULONG __stdcall Release();
	
public:
    JSObject(std::wstring id);
	~JSObject();

	HRESULT __stdcall QueryInterface(REFIID riid, void **ppvObject);

	HRESULT __stdcall get_Id(BSTR *Value);
	HRESULT __stdcall put_Id(BSTR Value);
	HRESULT __stdcall get_Properties(IJSProperties **Value);
	HRESULT __stdcall get_Methods(IJSMethods **Value);
	HRESULT __stdcall get_Events(IJSEvents **Value);
	HRESULT __stdcall get_Objects(IJSObjects **Value);
	HRESULT __stdcall FireEvent(BSTR Name, IJSArguments *Arguments);

    void FireEvent(std::wstring Name, IJSArguments* Arguments);

	/// <summary>
	/// When this method called, all properties getters are
	/// internally called looking for changes. Any change to the
	/// property value is sent to the client.
	/// </summary>
	HRESULT __stdcall ApplyChanges(void);

	/// <summary>
	/// Propagates the whole JSObject definition to the javascript
	/// client.
	/// </summary>
	HRESULT __stdcall ApplyModel(void);

	/// <summary>
	/// Identifier of the object. It must be unique among siblings
	/// objects.
	/// </summary>
    std::wstring Id();
	
    void Id(std::wstring value);

	/// <summary>
	/// List containing all properties of this object.
	/// </summary>
	CJSProperties* Properties();

	/// <summary>
	/// List containing all methods of this object.
	/// </summary>
	CJSMethods* Methods();

	/// <summary>
	/// List containing all events of this object.
	/// </summary>
	CJSEvents* Events();

	/// <summary>
	/// List containing all events of this object.
	/// </summary>
	CJSObjects* Objects();

	/// <summary>
	/// Fired when a method is executed on the remote object.
	/// </summary>
	void(*OnExecuteMethod)(IJSObject *Caller, IJSMethod *Method);

	/// <summary>
	/// Fired when a property value has been changed on the remote object.
	/// </summary>
	void(*OnPropertyChange)(IJSObject *Caller, IJSProperty *Prop);
};


typedef void(*JSMethodCallback)(IJSObject* Parent, IJSMethod* Prop);

class JSCallback : private IJSCallback
{
private:
	JSMethodCallback m_Proc;
public:
	JSCallback(JSMethodCallback Proc);
	HRESULT __stdcall Callback(IJSObject* Parent, IJSMethod* Method);
};


typedef void (*JSPropertySet)(IJSObject* Parent, IJSProperty* Prop);

class JSBinding : private IJSBinding
{
private:
	JSPropertySet m_Proc;
public:
	JSBinding(JSPropertySet Proc);
	HRESULT __stdcall Set(IJSObject* Parent, IJSProperty* Prop);
};


class CJSProperties : public IJSProperties
{
private:
	ULONG m_refcount;
	IJSObject* m_JSObject;
	IJSProperties* m_JSProperties;

	HRESULT __stdcall GetTypeInfo(UINT Index, LCID LocaleID, ITypeInfo FAR* FAR* TypeInfo);
	HRESULT __stdcall GetTypeInfoCount(UINT *Count);
	HRESULT __stdcall GetIDsOfNames(REFIID IID, LPOLESTR *Names, UINT NameCount, LCID LocaleID, DISPID *DispIDs);
	HRESULT __stdcall Invoke(DISPID DispID, REFIID IID, LCID LocaleID, WORD Flags, DISPPARAMS *Params, VARIANT *VarResult, EXCEPINFO *ExcepInfo, UINT *ArgErr);
	HRESULT __stdcall QueryInterface(REFIID riid, void **ppvObject);
	ULONG __stdcall AddRef();
	ULONG __stdcall Release();

public:
	CJSProperties(IJSObject* jsObject);
	~CJSProperties();

	HRESULT __stdcall get_Count(long *Value);
	HRESULT __stdcall get_Item(VARIANT Index, IJSProperty **Value);
	HRESULT __stdcall Add(BSTR Name, IJSProperty **OutRetVal);
	HRESULT __stdcall Clear(void);
	HRESULT __stdcall Remove(IJSProperty *Item);

	long Count();
	IJSProperty* Item(long Index);
    IJSProperty* Item(std::wstring Name);
    IJSProperty* Add(std::wstring Name);
};


class CJSMethods : public IJSMethods
{
private:
	ULONG m_refcount;
	IJSObject* m_JSObject;
	IJSMethods* m_JSMethods;

	HRESULT __stdcall GetTypeInfo(UINT Index, LCID LocaleID, ITypeInfo FAR* FAR* TypeInfo);
	HRESULT __stdcall GetTypeInfoCount(UINT *Count);
	HRESULT __stdcall GetIDsOfNames(REFIID IID, LPOLESTR *Names, UINT NameCount, LCID LocaleID, DISPID *DispIDs);
	HRESULT __stdcall Invoke(DISPID DispID, REFIID IID, LCID LocaleID, WORD Flags, DISPPARAMS *Params, VARIANT *VarResult, EXCEPINFO *ExcepInfo, UINT *ArgErr);
	HRESULT __stdcall QueryInterface(REFIID riid, void **ppvObject);
	ULONG __stdcall AddRef();
	ULONG __stdcall Release();

public:
	CJSMethods(IJSObject* jsObject);
	~CJSMethods();
	
	HRESULT __stdcall get_Count(long *Value);
	HRESULT __stdcall get_Item(VARIANT Index, IJSMethod **Value);
	HRESULT __stdcall Clear(void);
	HRESULT __stdcall Add(BSTR Name, IJSMethod **OutRetVal);
	HRESULT __stdcall Remove(IJSMethod *Item);
	
	long Count();
	IJSMethod* Item(long Index);
    IJSMethod* Item(std::wstring Name);
    IJSMethod* Add(std::wstring Name);
};


class CJSEvents : public IJSEvents
{
private:
	ULONG m_refcount;
	IJSObject* m_JSObject;
	IJSEvents* m_JSEvents;

	HRESULT __stdcall GetTypeInfo(UINT Index, LCID LocaleID, ITypeInfo FAR* FAR* TypeInfo);
	HRESULT __stdcall GetTypeInfoCount(UINT *Count);
	HRESULT __stdcall GetIDsOfNames(REFIID IID, LPOLESTR *Names, UINT NameCount, LCID LocaleID, DISPID *DispIDs);
	HRESULT __stdcall Invoke(DISPID DispID, REFIID IID, LCID LocaleID, WORD Flags, DISPPARAMS *Params, VARIANT *VarResult, EXCEPINFO *ExcepInfo, UINT *ArgErr);
	HRESULT __stdcall QueryInterface(REFIID riid, void **ppvObject);
	ULONG __stdcall AddRef();
	ULONG __stdcall Release();

public:
	CJSEvents(IJSObject* jsObject);
	~CJSEvents();
	
	HRESULT __stdcall get_Count(long *Value);
	HRESULT __stdcall get_Item(VARIANT Index, IJSEvent **Value);
	HRESULT __stdcall Clear(void);
	HRESULT __stdcall Add(BSTR Name, IJSEvent **OutRetVal);
	HRESULT __stdcall Remove(IJSEvent *Item);

	long Count();
	IJSEvent* Item(long Index);
    IJSEvent* Item(std::wstring Name);
    IJSEvent* Add(std::wstring Name);
};


class CJSObjects : public IJSObjects
{
private:
	ULONG m_refcount;
	IJSObject* m_JSObject;
	IJSObjects* m_JSObjects;

	HRESULT __stdcall GetTypeInfo(UINT Index, LCID LocaleID, ITypeInfo FAR* FAR* TypeInfo);
	HRESULT __stdcall GetTypeInfoCount(UINT *Count);
	HRESULT __stdcall GetIDsOfNames(REFIID IID, LPOLESTR *Names, UINT NameCount, LCID LocaleID, DISPID *DispIDs);
	HRESULT __stdcall Invoke(DISPID DispID, REFIID IID, LCID LocaleID, WORD Flags, DISPPARAMS *Params, VARIANT *VarResult, EXCEPINFO *ExcepInfo, UINT *ArgErr);
	HRESULT __stdcall QueryInterface(REFIID riid, void **ppvObject);
	ULONG __stdcall AddRef();
	ULONG __stdcall Release();

public:
	CJSObjects(IJSObject* jsObject);
	~CJSObjects();

	HRESULT __stdcall get_Count(long *Value);
	HRESULT __stdcall get_Item(VARIANT Index, IJSObject **Value);
	HRESULT __stdcall Clear(void);
	HRESULT __stdcall Add(BSTR Id, IJSObject **Value);
	HRESULT __stdcall Remove(IJSObject *Item);

	long Count();
	IJSObject* Item(long Index);
    IJSObject* Item(std::wstring Name);
    IJSObject* Add(std::wstring Name);
};
